This is nano.info, produced by makeinfo version 4.8 from nano.texi.

INFO-DIR-SECTION Editors
START-INFO-DIR-ENTRY
* nano: (nano).                 Small and friendly text editor.
END-INFO-DIR-ENTRY


File: nano.info,  Node: Top,  Next: Introduction,  Prev: (dir),  Up: (dir)

   This manual documents GNU `nano', a small and friendly text editor.

* Menu:

* Introduction::
* Editor Basics::
* Online Help::
* Feature Toggles::
* The File Browser::
* Pico Compatibility::
* Building and Configure Options::


File: nano.info,  Node: Introduction,  Next: Editor Basics,  Prev: Top,  Up: Top

1 Introduction
**************

GNU `nano' is a small and friendly text editor.  Besides basic text
editing, `nano' offers many extra features like an interactive search
and replace, goto line number, auto-indentation, feature toggles,
internationalization support, and filename tab completion.

* Menu:

* Overview::
* Command Line Options::


File: nano.info,  Node: Overview,  Next: Command Line Options,  Prev: Introduction,  Up: Introduction

1.1 Overview
============

`nano' +LINE,COLUMN [GNU long option] [option] [ FILE ... ]

   The original goal for `nano' was a complete bug-for-bug compatible
emulation of Pico, but `nano''s main goal is to be as compatible as
possible while offering a superset of Pico's functionality.  Also see
*Note Pico Compatibility::, for other differences.

   Email bug reports to <nano@nano-editor.org>.


File: nano.info,  Node: Command Line Options,  Prev: Overview,  Up: Introduction

1.2 Command Line Options
========================

`nano' takes the following options from the command line:

`+LINE,COLUMN'
     Start at line number LINE and column number COLUMN instead of the
     default of line 1, column 1.

`-?'
     Same as `-h, --help'.

`-A, --smarthome'
     Make the Home key smarter.  When Home is pressed anywhere but at
     the very beginning of non-whitespace characters on a line, the
     cursor will jump to that beginning (either forwards or backwards).
     If the cursor is already at that position, it will jump to the
     true beginning of the line.

`-B, --backup'
     When saving a file, back up the previous version of it to the
     current filename suffixed with a ~.

`-C, --backupdir=[dir]'
     Set the directory where `nano' puts unique backup files if file
     backups are enabled.

`-E, --tabstospaces'
     Convert typed tabs to spaces.

`-F, --multibuffer'
     Enable multiple file buffers, if available.

`-I, --ignorercfiles'
     Don't look at SYSCONFDIR/nanorc or ~/.nanorc, if nanorc support is
     available.

`-K, --rebindkeypad'
     Interpret the numeric keypad keys so that they all work properly.
     You should only need to use this option if they don't, as mouse
     support won't work properly with this option enabled.

`-L, --nonewlines'
     Don't add newlines to the ends of files.

`-N, --noconvert'
     Don't convert files from DOS/Mac format.

`-Q [str], --quotestr [str]'
     Set the quoting string for justifying.  The default is

          `^([ \t]*[|>:}#])+'

     if regular expression support is available, or "> " otherwise.
     Note that `\t' above stands for a literal Tab character.

`-R, --restricted'
     Restricted mode: Don't read or write to any file not specified on
     the command line, read any nanorc files, allow suspending, or
     allow a file to be appended to, prepended to, or saved under a
     different name if it already has one.  Also accessible by invoking
     `nano' with any name beginning with 'r' (e.g. "rnano").

`-S, --smooth'
     Enable smooth scrolling.

`-T [num], --tabsize=[#cols]'
     Set the displayed tab length to #cols columns.  The value of #cols
     must be greater than 0.  The default value is 8.

`-U, --quickblank'
     Do quick statusbar blanking.  Statusbar messages will disappear
     after 1 keystroke instead of 25.  Note that -c cancels this out.

`-V, --version'
     Print the version number and copyright and quit.

`-W, --wordbounds'
     Detect word boundaries more accurately by treating punctuation
     characters as part of a word.

`-Y, --syntax=[str]'
     Specify a specific syntax highlighting from the nanorc to use, if
     available.

`-c, --const'
     Constantly display the cursor position and line number on the
     statusbar.  Note that this cancels out -U.

`-d, --rebinddelete'
     Interpret the Delete key differently so that both Backspace and
     Delete work properly.  You should only need to use this option if
     Backspace acts like Delete on your system.

`-h, --help'
     Print the usage and exit.

`-i, --autoindent'
     Automatically indent new lines to the same number of spaces and
     tabs as the previous line.

`-k, --cut'
     Cut from the current cursor position to the end of the current
     line.

`-l, --nofollow'
     When writing files, if the given file is a symbolic link, it is
     removed and a new file is created.

`-m, --mouse'
     Enables the use of the mouse to select text (currently only useful
     for running under the X Window System).

`-o [dir], --operatingdir=[dir]'
     Set operating directory.  Makes `nano' set up something similar to
     a chroot.

`-p, --preserve'
     Preserve the ^Q (XON) and ^S (XOFF) sequences so data being sent
     to the editor can be can be stopped and started.

`-r [#cols], --fill=[#cols].'
     Wrap lines at column #cols.  If this value is 0 or less, wrapping
     will occur at #cols less the width of the screen, allowing it to
     vary along with the width of the screen if the screen is resized.
     The default value is -8.

`-s [prog], --speller=[prog]'
     Invoke [prog] as the spell checker.  By default, `nano' uses the
     command specified in the SPELL environment variable, or, if SPELL
     is not set, its own interactive spell checker that requires the
     `spell' program to be installed on your system.

`-t, --tempfile'
     Don't ask whether or not to save the current contents of the file
     when exiting, assume yes.  This is most useful when using `nano'
     as the composer of a mailer program.

`-x, --nohelp'
     In Expert Mode, the Shortcut Lists will not appear at the bottom
     of the screen.  This affects the location of the statusbar as
     well, as in Expert Mode it is located at the very bottom of the
     editor.

     Note: When accessing the help system, Expert Mode is temporarily
     disabled to display the help system navigation keys.

`-v, --view'
     Don't allow the contents of the file to be altered.  Note that this
     option should NOT be used in place of correct file permissions to
     implement a read-only file.

`-w, --nowrap'
     Don't wrap long lines at any length.  This option overrides any
     value for -r.

`-z, --suspend'
     Enable `nano''s suspend ability using the system's suspend
     keystroke (usually ^Z).

`-a, -b, -e, -f, -g, -j'
     Ignored, for compatibility with Pico.


File: nano.info,  Node: Editor Basics,  Next: Online Help,  Prev: Introduction,  Up: Top

2 Editor Basics
***************

* Menu:

* Entering Text::
* Special Functions::
* The Titlebar::
* The Statusbar::
* Shortcut Lists::


File: nano.info,  Node: Entering Text,  Next: Special Functions,  Prev: Editor Basics,  Up: Editor Basics

2.1 Entering Text
=================

All key sequences in `nano' are entered using the keyboard.  `nano' is
a "modeless" editor.  All keys with the exception of Control and Meta
key sequences will enter text into the file being edited.


File: nano.info,  Node: Special Functions,  Next: The Titlebar,  Prev: Entering Text,  Up: Editor Basics

2.2 Special Functions
=====================

Special functions use the Control key (displayed in the help and
shortcut lists as ^), the Meta key (displayed as M), or the Esc key.

   * Control key sequences are entered by holding down the Control key
     and pressing the desired key, or by pressing the Esc key twice and
     pressing the desired key.

   * Pressing Esc twice and then typing a three-digit number from 000
     to 255 will enter the character with the corresponding ASCII code.

   * Meta key sequences can be entered in a number of possible ways:
     Pressing the Escape key, then releasing it and pressing the
     desired key, or holding down the Alt key while pressing the
     desired key.  This varies from keyboard to keyboard, and certain
     commercial operating systems "swallow" the Alt key so that it
     never reaches the application.  If your operating system does
     this, you should use the Escape key to generate Meta key sequences.


File: nano.info,  Node: The Titlebar,  Next: The Statusbar,  Prev: Special Functions,  Up: Editor Basics

2.3 The Titlebar
================

The titlebar is the line displayed at the top of the editor.  There are
three sections: left, center and right.  The section on the left
displays the version of `nano' being used.  The center section displays
the current file name, or "New Buffer" if the file has not yet been
named.  The section on the right will display "Modified" if the file
has been modified since it was last saved or opened.

   Special modes: When `nano' is in "File browser" mode, the center
section will display the current directory instead of the filename.
*Note The File Browser::.


File: nano.info,  Node: The Statusbar,  Next: Shortcut Lists,  Prev: The Titlebar,  Up: Editor Basics

2.4 The Statusbar
=================

The statusbar is located three lines from the bottom of the screen (or
the bottom line in Expert Mode.  *Note Expert Mode::, for more info).

   The Statusbar shows important and informational messages.  Any error
messages that occur from using the editor will appear on the statusbar.
Any questions that are asked of the user will be asked on the statusbar,
and any user input (search strings, file names, etc) will be input on
the statusbar.


File: nano.info,  Node: Shortcut Lists,  Prev: The Statusbar,  Up: Editor Basics

2.5 Shortcut Lists
==================

The Shortcut Lists are the two lines at the bottom of the screen which
show some of the more commonly used functions in the editor.


File: nano.info,  Node: Online Help,  Next: Feature Toggles,  Prev: Editor Basics,  Up: Top

3 Online Help
*************

The online help system in `nano' is available by pressing ^G.  It is
fairly self explanatory, documenting the various parts of the editor
and available keystrokes.  Navigation is via the ^Y (Page Up) and ^V
(Page Down) keys.  ^X exits the help system.


File: nano.info,  Node: Feature Toggles,  Next: The File Browser,  Prev: Online Help,  Up: Top

4 Feature Toggles
*****************

Toggles allow you to change certain aspects of the editor that would
normally be done via command line options.  They are invoked via
certain Meta key sequences.  *Note Special Functions::, for more info.
The following global toggles are available:

`Backup Files Toggle (Meta-B)'
     toggles the -B (`--backup') command line option.

`Constant Cursor Position Display Toggle (Meta-C)'
     toggles the -c (`--const') command line option.

`Multiple File Buffers Toggle (Meta-F)'
     toggles the -F (`--multibuffer') command line option.

`Smart Home Key Toggle (Meta-H)'
     toggles the -A (`--smarthome') command line option.

`Auto Indent Toggle (Meta-I)'
     toggles the -i (`--autoindent') command line option.

`Cut To End Toggle (Meta-K)'
     toggles the -k (`--cut') command line option.

`Long Line Wrapping Toggle (Meta-L)'
     toggles the -w (`--nowrap') command line option.

`Mouse Support Toggle (Meta-M)'
     toggles the -m (`--mouse') command line option.

`No Conversion From DOS/Mac Format Toggle (Meta-N)'
     toggles the -N (`--noconvert') command line option.

`More Space For Editing Toggle (Meta-O)'
     toggles the -O (`--morespace') command line option.

`Whitespace Display Toggle (Meta-P)'
     toggles whitespace display mode if you have a "whitespace" option
     in your nanorc.

`Tabs to Spaces Toggle (Meta-Q)'
     toggles the -E (`--tabstospaces') command line option.

`Smooth Scrolling Toggle (Meta-S)'
     toggles the -S (`--smooth') command line option.

`Expert/No Help Toggle (Meta-X)'
     toggles the -x (`--nohelp') command line option.

`Color Syntax Highlighting Toggle (Meta-Y)'
     toggles color syntax highlighting if you have color syntaxes in
     your nanorc.

`Suspend Toggle (Meta-Z)'
     toggles the -z (`--suspend') command line option.



File: nano.info,  Node: The File Browser,  Next: Pico Compatibility,  Prev: Feature Toggles,  Up: Top

5 The File Browser
******************

When reading or writing files, pressing ^T will invoke the file browser.
Here, one can navigate directories in a graphical manner in order to
find the desired file.

   Basic movement in the file browser is accomplished with the arrow
keys and page up/down.  The behavior of the enter (or `s') key varies
by what is currently selected.  If the currently selected object is a
directory, the file browser will enter and display the contents of the
directory.  If the object is a file, this filename and path are copied
to the statusbar and the file browser is exited.


File: nano.info,  Node: Pico Compatibility,  Next: Building and Configure Options,  Prev: The File Browser,  Up: Top

6 Pico Compatibility
********************

`nano' attempts to emulate Pico as closely as possible, but there are
certain differences between the editors:

`Search and Replace History'
     As of version 1.1.99pre1 of `nano', text entered as search or
     replace strings will be stored and can be accessed with the up/down
     arrow keys.  Previously, `nano' offered a more consistent, but
     incompatible with Pico, method for entering search and replace
     strings.  In the old method, previous entries would be displayed
     by default as editable text in front of the cursor, as opposed to
     being bracketed and uneditable as it is in Pico.  The old behavior
     could be made compatible with Pico via the `-p' option, but recent
     versions of Pico use the `-p' option to preserve the XON and XOFF
     sequences within the editor.  Since with the new method search and
     replace strings can still be edited by simply hitting the up arrow
     key once, the old method was removed completely.

`Writing or Appending Selected Text to Files'
     Text selected using the Control-Caret (^^) key can be written out
     or appended to a new or existing file using the Writeout key (^O).

`Toggles'
     Many options which alter the functionality of the program can be
     "toggled" on or off using Meta key sequences, meaning the program
     does not have to be restarted to turn a particular feature of the
     editor on or off.  Please see the internal help function (^G) for
     a list of what functions can be toggled for a particular version
     of `nano'.  Also see *Note Feature Toggles::, though this may be
     out of date.

`Cursor Position Display'
     The output of the "Display Cursor Position" in `nano' displays the
     given column position, as well as the row and total character
     position of the cursor.

`Interactive Replace and Spell Checker'
     It is worth noting that the `nano' replace function is interactive,
     i.e, it does not stop after one search string is found and
     automatically replace it.  The `nano' implementation will stop at
     each search string found and query whether to replace this
     instance or not.  The internal spell checker operates similarly.
     Note that these is no way to force these functions to behave in
     the Pico fashion.  As of version 1.1.99pre1, misspelled words are
     sorted and trimmed for uniqueness in the internal spell checker
     such that the words 'apple' and 'Apple' will be prompted for
     correction separately.


File: nano.info,  Node: Building and Configure Options,  Prev: Pico Compatibility,  Up: Top

7 Building and Configure Options
********************************

Building `nano' from source is fairly straightforward if you are
familiar with compiling programs with autoconf support:

   * tar xvfz nano-x.y.z.tar.gz (where x.y.z is the version of `nano')

   * cd nano-x.y.z/

   * ./configure

   * make

   * make install

`--disable-browser'
     Disable the mini file browser when reading or writing files.

`--disable-help'
     Disable the help function.  Doing this makes the binary much
     smaller, but makes it difficult for new users to learn more than
     very basic things about using the editor.

`--disable-justify'
     Disable the justify and unjustify functions.

`--disable-mouse'
     Disable all mouse functionality.  This also disables the -m
     command line option, which enables the mouse functionality.

`--disable-operatingdir'
     Disable setting the operating directory.  This also disables the -o
     command line option, which sets the operating directory.

`--disable-speller'
     Disable use of the spell checker.  This also disables the -s
     command line option, which allows specifying an alternate spell
     checker.

`--disable-tabcomp'
     Disable the tab completion code when reading or writing files.

`--disable-wrapping'
     Disable all long line wrapping.  This also eliminates the -w
     command line option, which enables long line wrapping.

`--enable-tiny'
     This option disables all the above.  It also disables some of the
     larger internals of the editor, like the marking code and the cut
     to line code.  It also disables the function toggles.

`--enable-debug'
     Enable support for runtime debug output.  This can get pretty
     messy, so chances are you only want this feature to work on the
     nano source.

`--enable-extra'
     Enable extra features.  At the moment, this is just easter egg-type
     stuff.

`--enable-color'
     Enable support for syntax coloring of files.  See the nanorc
     documentation for more details.  The nanorc feature will also be
     enabled.

`--enable-multibuffer'
     Enable support for opening multiple files at a time and switching
     between them on the fly.

`--enable-nanorc'
     Enable support for reading the nanorc file at startup.  You can
     store custom settings in the nanorc file rather than having to
     pass command line options to get desired behavior.

`--enable-all'
     Shortcut for enabling the above four features (extra, color,
     multibuffer, and nanorc).

`--disable-nls'
     Disables Native Language support.  This will disable use of the
     available GNU `nano' translations.

`--disable-wrapping-as-root'
     Disable long line wrapping by default when nano is run as root.

`--enable-utf8'
     Enable support for reading and writing Unicode files.  This will
     require either the wide version of ncurses, or a UTF-8-enabled
     version of Slang.

`--disable-utf8'
     Disable support for reading and writing Unicode files.

`--with-slang'
     Compiling `nano' with Slang is supported, and will make the binary
     notably smaller than if compiled with ncurses or other curses
     libraries.




Tag Table:
Node: Top199
Node: Introduction509
Node: Overview936
Node: Command Line Options1438
Ref: Expert Mode6114
Node: Editor Basics6952
Node: Entering Text7181
Node: Special Functions7527
Node: The Titlebar8610
Node: The Statusbar9316
Node: Shortcut Lists9903
Node: Online Help10159
Node: Feature Toggles10536
Node: The File Browser12477
Node: Pico Compatibility13188
Node: Building and Configure Options15846

End Tag Table
